#include "SDL/SDL.h"
#include "SDL/SDL_gfxPrimitives.h"
#include <sstream>

#define SCREEN_WIDTH 320
#define SCREEN_HEIGHT 240
#define SCREEN_DEPTH 16

int main(int argc, char *argv[]) {
	int x, y;
	bool isMouseDown = false;
	bool isRunning = true;

	SDL_Init(SDL_INIT_JOYSTICK | SDL_INIT_VIDEO);
	SDL_Surface* screen = SDL_SetVideoMode(SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_DEPTH, SDL_SWSURFACE);
	SDL_Joystick* joystick = SDL_JoystickOpen(0);
	Uint32 time = SDL_GetTicks();

	for ( int i = 0; i < 320; i = i + 40 )
	{
		lineColor(screen, i, 0, i, 240, 0x66666666);
	}
	for ( int i = 0; i < 240; i = i + 40 )
	{
		lineColor(screen, 0, i, 320, i, 0x66666666);
	}

	while (isRunning)
	{
		if (time+100 < SDL_GetTicks())
			isMouseDown = false;

		SDL_Event event;
		if ( SDL_PollEvent( &event ) )
		{
			switch (event.type)
			{
				case SDL_JOYBUTTONDOWN:
					isRunning = false;
					break;

				case SDL_MOUSEBUTTONDOWN:
					x = event.button.x;
					y = event.button.y;
					break;

				case SDL_MOUSEMOTION:
					if (!isMouseDown)
					{
						isMouseDown = true;
						time = SDL_GetTicks();
					}
					else
					{
						lineColor(screen, (Sint16)x, (Sint16)y, (Sint16)event.motion.x, (Sint16)event.motion.y, 0xFFFFFFFF);
						time = SDL_GetTicks();
					}
					x = event.motion.x;
					y = event.motion.y;
					//Uint8* p = (Uint8 *)screen->pixels + y * screen->pitch + x * screen->format->BytesPerPixel;
					//*p=0xff;
					break;
			}

			SDL_Rect rect;
			rect.x = rect.y = 20;
			rect.w = 50;
			rect.h = 14;
			SDL_FillRect(screen, &rect, 0x66666666);
			std::stringstream txt;
			txt << x << " " << y;
			stringColor(screen, 20, 20, txt.str().c_str(), 0xFFFFFFFF);
		}
		SDL_Flip(screen);
		SDL_Delay(0.01f);
	}
	SDL_SaveBMP(screen, "./screenshot.bmp");
	SDL_JoystickClose(joystick);
	SDL_Quit();
	return 0;
}

